
/*---------------------------------------------------------------------------
 * Copyright (C) 1999,2000 Dallas Semiconductor Corporation, All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Dallas Semiconductor
 * shall not be used except as stated in the Dallas Semiconductor
 * Branding Policy.
 *---------------------------------------------------------------------------
 */

package com.dalsemi.protocol;



import java.net.FileNameMap;
import java.util.StringTokenizer;


public class DefaultFileNameMap
   implements FileNameMap
{
   static String[] suffix = null;
   static String[] type   = null;

   /**
    * Constructor DefaultFileNameMap
    *
    *
    */
   public DefaultFileNameMap ()
   {

      // Tom's cool trick to dynamically initialize these arrays.
      if (suffix == null)
      {
         String[] temp =
         {
            "ai|eps|ps", "rtf", "tex", "texinfo|texi", "t|tr|roff", "au|snd",
            "aif|aiff|aifc", "wav", "gif", "ief", "jpeg|jpg|jpe", "tiff|tif",
            "xwd", "html", "txt", "mpeg|mpg|mpe", "qt|mov", "avi", "movie"
         };

         suffix = temp;

         String[] temp2 =
         {
            "application/postscript", "application/rtf", "application/x-tex",
            "application/x-texinfo", "application/x-troff", "audio/basic",
            "audio/x-aiff", "audio/x-wav", "image/gif", "image/ief",
            "image/jpeg", "image/tiff", "image/x-xwindowdump", "text/html",
            "text/plain", "video/mpeg", "video/quicktime", "video/x-msvideo",
            "video/x-sgi-movie"
         };

         type = temp2;
      }
   }

   /**
    * Method getContentTypeFor
    *
    *
    * @param fileName
    *
    * @return
    *
    */
   public String getContentTypeFor (String fileName)
   {
      for (int i = 0; i < suffix.length; i++)
      {
         StringTokenizer st = new StringTokenizer(suffix [i], "|");

         while (st.hasMoreTokens())
            if (fileName.toLowerCase().endsWith("." + st.nextToken()))
               return type [i];
      }

      return null;
   }
}
