
/*---------------------------------------------------------------------------
 * Copyright (C) 1999,2000 Dallas Semiconductor Corporation, All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Dallas Semiconductor
 * shall not be used except as stated in the Dallas Semiconductor
 * Branding Policy.
 *---------------------------------------------------------------------------
 */

/*
 * Handler.java
 * KLA
 * Extension of the URLStreamHandler class to support http protocol.
 *
 * NOTE THAT AN FTP REQUEST THROUGH A PROXY SERVER CAN BE DEALT WITH
 * THROUGH HTTP
 *
 * HACK ISSUES
 * 1 proxy as a system property
 */
package com.dalsemi.protocol.http;



import java.net.*;
import java.io.IOException;


public class Handler
   extends URLStreamHandler
{
   protected URLConnection openConnection (URL u)
      throws IOException
   {
      String proxyServer = com.dalsemi.tininet.TININet.getProxyServer();
      int    proxyPort   = com.dalsemi.tininet.TININet.getProxyPort();

      if ((proxyServer == null) || (proxyServer.length() == 0))
         return new Connection(u);
      else
         return new Connection(u, proxyServer, proxyPort);
   }
}
